/*
   Copyright (C) 2023 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangements/agreements contact
   the copyright holder:

   Michael N. Moran
   218 Wilshire Terrace       mike@mnmoran.org
   White, GA, USA 30184       http://mnmoran.org
*/

#ifndef _oscl_uml_hsm_generator_cpp_endstateh_
#define _oscl_uml_hsm_generator_cpp_endstateh_

#include <vector>
#include <string>
#include "oscl/queue/queue.h"
#include "records.h"

/** */
namespace Oscl {
/** */
namespace UML {
/** */
namespace HSM {
/** */
namespace Generator {

/**	This contains the state is populated
	with items that have been allocated
	as the visitation progresses.

	It is responsible for the
	life-cycle of the items it contains.
	That is to say, when it is destroyed
	it will delete all of the items that
	it contains.

	It may be copied in which case its
	items and their life-cycle will become
	the responsibility of the destination
	copy.

	Rationale:
	Many other items generated by the
	visitation contain pointer-references
	to items contained in this EndState.
	Therefore, the items contained in the
	EndState must not deleted until all
	of the those items are no longer in
	use.
 */
class EndState {
	public:
		/** */
		Oscl::Queue< ResetRecord >		_resetList;

		/** There will actually only ever be one
			event record in this list.
		 */
		Oscl::Queue< EventRecord >			_eventList;

		/** */
		Oscl::Queue< TriggerRecord >		_triggerList;

		/** */
		Oscl::Queue< ContextFuncRecord >	_contextFuncList;

		/** */
		Oscl::Queue< ContextArgsRecord >	_contextArgsList;

		/** */
		Oscl::Queue< ContextArgRecord >		_contextArgList;

		/** */
		Oscl::Queue< ArgsRecord >			_argsList;

		/** */
		Oscl::Queue< ArgRecord >			_argList;

		/** */
		Oscl::Queue< GuardRecord >			_guardList;

		/** */
		Oscl::Queue< GuardExpRecord >		_guardExpList;

		/** */
		Oscl::Queue< GroupRecord >			_groupList;

		/** */
		Oscl::Queue< ActionsRecord >		_actionsList;

		/** */
		Oscl::Queue< ActionRecord >			_actionList;

		/** */
		Oscl::Queue< VarFuncRecord >		_varFuncList;

		/** */
		Oscl::Queue< VarExpRecord >			_varExpList;

		/** */
		Oscl::Queue< EntryRecord >			_entryList;

		/** */
		Oscl::Queue< ExitRecord >			_exitList;

		/** */
		Oscl::Queue< BinOperatorRecord >	_binOpList;

		/** */
//		Oscl::Queue< BinExpRecord >			_binExpList;

		/** */
		Oscl::Queue< BinOperandRecord >		_binOperandList;

		/** */
		Oscl::Queue< ChoiceRecord >			_choiceList;

		/** */
		Oscl::Queue< EventsRecord >			_eventsList;

		/** */
		Oscl::Queue< ParametersRecord >		_parametersList;

		/** */
		Oscl::Queue< NamespaceRecord >		_namespaceList;

		/** */
		Oscl::Queue< IncludeFileRecord >	_includeFileList;

		/** */
		Oscl::Queue< StateRecord >		_stateList;

		/** */
		Oscl::Queue< ChoicesRecord >	_choicesList;

		/** */
		Oscl::Queue< TargetRecord >	_targetList;

	public:
		/** */
		~EndState();

		/** This operator appends the items to
			another EndState, emptying this
			EndState and assigning responsibility
			for the life-cycle of those items to
			the other EndState.
		 */
		void	operator += (EndState& other) noexcept;
	};

}
}
}
}

#endif
